# coding: utf-8
"""

    ファイル名：   synthesizer.py

    処理内容：

        synthesizer メイン

"""
from __future__ import unicode_literals

import sys
import os
# ----- pyinstaller help imports begin -----------------------------------------
import symbol
import packaging.version
import packaging.specifiers
import numpy
#    mkl_intel_thread.dll
#    mkl_core.dll
#    libiomp5md.dll
#    mkl_avx2.dll
#    mkl_def.dll
import pylab
import pandas
# ----- pyinstaller help imports end   -----------------------------------------

thisdir_ = os.path.dirname( os.path.abspath( __file__ ) )
libdir_ = thisdir_ + '/lib'
if os.path.exists( libdir_ ):
    sys.path.append( libdir_ )
else:
    updir_ = os.path.dirname( thisdir_ )
    libdir_ = updir_ + '/lib'
    if os.path.exists( libdir_ ):
        sys.path.append( libdir_ )

keklib_dir_ = os.path.dirname( libdir_ ) + '/lib.kek.saxs'
if os.path.exists( keklib_dir_ ):
    sys.path.append( keklib_dir_ )

from CommandLineOptions import opts

if opts.version:
    from AppVersion             import get_app_version_string
    print( get_app_version_string() )
    exit()

if opts.command:
    from CommandController import Controller
    cmd = Controller( opts )
    cmd.execute()
else:
    if sys.version_info > (3,):
        import tkinter as Tk
        import tkinter.simpledialog
        import tkinter.scrolledtext
        import tkinter.ttk
        import tkinter.tix
    else:
        import Tkinter as Tk
        import tkSimpleDialog
        import ScrolledText
        import ttk
        import Tix
    import matplotlib.backends.backend_tkagg
    import mpl_toolkits.axes_grid1
    import mpl_toolkits.mplot3d
    from idlelib.ToolTip import ToolTip

    root = Tk.Tk()
    root.withdraw()

    from GuiController import Controller
    gui = Controller( root, opts )
    gui.mainloop()
    gui.__del__()   # 必要。これがないと RuntimeError('sys.meta_path must be a list of import hooks')
                    # 参考URL
                    # http://matplotlib.1069221.n5.nabble.com/Exception-RuntimeError-sys-meta-path-must-be-a-list-of-import-hooks-td25010.html
